//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits:

struct MyBuffer {
	float4 tex0;
	float4 tex1;
};

Texture3D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

RWStructuredBuffer<MyBuffer> Output : BACKBUFFER;

//shared float4 sharedMem[TOTALCOUNT];

float3 R;

[numthreads(8, 8, 8)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x + tid.z * (R.y * R.x);
	
	float3 uvw = float3 ( tid.x / R.x , tid.y / R.y, tid.z / R.z);
	float4 col = tex0.SampleLevel(s0, uvw, 0);
	
	Output[idx].tex0 = col;
	Output[idx].tex1 = 1 - col;
	
}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




