//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2D texture2d <string uiname="Texture";>;

struct MyBuffer {
	float4 tex0;
	float4 tex1;
};
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};
Texture3D tex0;
float3 R;
RWStructuredBuffer<MyBuffer> Output : BACKBUFFER;

[numthreads(8, 8, 8)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x + tid.z * (R.y * R.x);
	
	float3 uvw = float3 ( tid.x / R.x , tid.y / R.y, tid.z / R.z);
	float4 col = tex0.SampleLevel(s0, uvw, 0);
	
	Output[idx].tex0 = float4((int)(length((tid.xyz / (float)R.r - float3(.15,.2,.25)) - 0.01) > .2), 0, 0, 0);
	Output[idx].tex1 = float4((int)(length((tid.xyz / (float)R.r - float3(.15,.05,.25)) - 0.01) > .1), 0, 0, 0);
	
}

technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}